package com.usky.iot.controller.web;


import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.usky.common.core.bean.ApiResult;
import com.usky.common.core.bean.CommonPage;
import com.usky.common.log.annotation.Log;
import com.usky.common.log.enums.BusinessType;
import com.usky.iot.domain.BaseGgpFacility;
import com.usky.iot.service.BaseGgpFacilityService;
import com.usky.iot.service.vo.BaseGgpFacilityExportVo;
import com.usky.iot.service.vo.BaseGgpFacilityRequest;
import com.usky.iot.service.vo.BaseGgpFacilityTypeVO;
import com.usky.iot.service.vo.DmpDeviceInfoRequest;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * <p>
 * 地理信息 前端控制器
 * </p>
 *
 * @author han
 * @since 2023-06-02
 */
@RestController
@RequestMapping("/baseGgpFacility")
public class BaseGgpFacilityController {
    @Autowired
    private BaseGgpFacilityService baseGgpFacilityService;

    /**
     * 新增
     * @param baseGgpFacility
     * @return
     */
    @PostMapping("/add")
    public ApiResult<Void> add(@RequestBody BaseGgpFacility baseGgpFacility){
        baseGgpFacilityService.add(baseGgpFacility);
        return ApiResult.success();
    }

    /**
     * 修改
     * @param baseGgpFacility
     * @return
     */
    @PutMapping("/edit")
    public ApiResult<Void> edit(@RequestBody BaseGgpFacility baseGgpFacility){
        baseGgpFacilityService.update(baseGgpFacility);
        return ApiResult.success();
    }


    /**
     * 分页
     * @param baseGgpFacilityRequest
     * @return
     */
    @Log(title = "分页", businessType = BusinessType.OTHER)
    @PostMapping("/page")
    public ApiResult<CommonPage<BaseGgpFacility>> page(@RequestBody BaseGgpFacilityRequest baseGgpFacilityRequest)
    {
        return ApiResult.success(baseGgpFacilityService.page(baseGgpFacilityRequest));
    }



    /**
     * 删除记录
     */
    @DeleteMapping("/{id}")
    public ApiResult<Void> remove(@PathVariable("id") Integer id)
    {
        baseGgpFacilityService.remove(id);
        return ApiResult.success();
    }

    /**
     * 导出
     * @param baseGgpFacilityRequest
     * @param response
     * @throws IOException
     */
    @PostMapping("/export")
    public void export(@RequestBody BaseGgpFacilityRequest baseGgpFacilityRequest, HttpServletResponse response) throws IOException {
        List<BaseGgpFacilityExportVo> list = baseGgpFacilityService.recordLsitExport(baseGgpFacilityRequest);
        ExcelUtil<BaseGgpFacilityExportVo> util = new ExcelUtil<BaseGgpFacilityExportVo>(BaseGgpFacilityExportVo.class);
        util.exportExcel(response, list, "地理设施", "地理设施");
    }

}

