package com.usky.iot.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.StringUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.usky.common.security.utils.SecurityUtils;
import com.usky.iot.domain.BaseFacilityType;
import com.usky.iot.domain.BaseGgpFacility;
import com.usky.iot.mapper.BaseFacilityTypeMapper;
import com.usky.iot.service.BaseFacilityTypeService;
import com.usky.common.mybatis.core.AbstractCrudService;
import com.usky.iot.service.vo.BaseGgpFacilityTypeNumVO;
import com.usky.iot.service.vo.BaseGgpFacilityTypeVO;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 * 设施类型 服务实现类
 * </p>
 *
 * @author han
 * @since 2023-06-06
 */
@Service
public class BaseFacilityTypeServiceImpl extends AbstractCrudService<BaseFacilityTypeMapper, BaseFacilityType> implements BaseFacilityTypeService {
    @Override
    public List<BaseGgpFacilityTypeVO> typeInfo() {
        List<BaseGgpFacilityTypeVO> list = new ArrayList<>();
        LambdaQueryWrapper<BaseFacilityType> queryWrapper = Wrappers.lambdaQuery();
        queryWrapper.eq(BaseFacilityType::getTenantId, 1);
        List<BaseFacilityType> list1 = this.list(queryWrapper);
        if (CollectionUtils.isNotEmpty(list1)) {
            List<Integer> typeIdList = new ArrayList<>();
            for (int i = 0; i < list1.size(); i++) {
                typeIdList.add(list1.get(i).getId());
            }
            List<BaseGgpFacilityTypeNumVO> list2 = new ArrayList<>();
            List<BaseGgpFacilityTypeNumVO> list3 = new ArrayList<>();
            List<BaseGgpFacilityTypeNumVO> list4 = new ArrayList<>();
            List<BaseGgpFacilityTypeNumVO> list5 = new ArrayList<>();
            if (CollectionUtils.isNotEmpty(typeIdList)) {
                Integer[] a2 = typeIdList.toArray(new Integer[typeIdList.size()]);
                list2 = baseMapper.typeNumList(1);
                list3 = baseMapper.typeNormalNumList(1);
                list4 = baseMapper.typeUpkeepNumList(1);
                list5 = baseMapper.typeCloseNumList(1);
            }
            BaseGgpFacilityTypeVO baseGgpFacilityTypeVO = new BaseGgpFacilityTypeVO();
            baseGgpFacilityTypeVO.setTypeNum(3);
            List<BaseGgpFacilityTypeNumVO> list8 = new ArrayList<>();
            if (CollectionUtils.isNotEmpty(list2)) {
                for (int i = 0; i < list2.size(); i++) {
                    for (int j = 0; j < list3.size(); j++) {
                        if (list2.get(i).getId().equals(list3.get(j).getId())){
                            list2.get(i).setNormalFacilityNum(list3.get(j).getNormalFacilityNum());
                        }
                    }
                    for (int k = 0; k < list4.size(); k++) {
                        if (list2.get(i).getId().equals(list4.get(k).getId())){
                            list2.get(i).setUpkeepFacilityNum(list4.get(k).getUpkeepFacilityNum());
                        }
                    }
                    for (int g = 0; g < list5.size(); g++) {
                        if (list2.get(i).getId().equals(list5.get(g).getId())){
                            list2.get(i).setCloseFacilityNum(list5.get(g).getCloseFacilityNum());
                        }
                    }
                    list8.add(list2.get(i));
                }
                baseGgpFacilityTypeVO.setBaseGgpFacilityTypeNumVO(list8);
                list.add(baseGgpFacilityTypeVO);
            }
        }
        return list;
    }
}
